package com.youdao.YDatabase;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;

import com.j256.ormlite.android.apptools.OrmLiteSqliteOpenHelper;
import com.j256.ormlite.misc.TransactionManager;
import com.j256.ormlite.support.ConnectionSource;

import java.io.File;
import java.io.InputStream;
import java.util.concurrent.Callable;

/**
 * Created by Yafei on 2015/1/7.
 */
public class YDataHelper extends OrmLiteSqliteOpenHelper {

    private YTableUtils yTableUtils;

    /**
     * 构造函数
     * @param context
     * @param databaseName
     * @param factory
     * @param databaseVersion
     */
    public YDataHelper(Context context, String databaseName, SQLiteDatabase.CursorFactory factory, int databaseVersion) {
        super(context, databaseName, factory, databaseVersion);
        yTableUtils = new YTableUtils(connectionSource);
    }

    /**
     * 构造函数
     * @param context
     * @param databaseName
     * @param factory
     * @param databaseVersion
     * @param configFileId
     */
    public YDataHelper(Context context, String databaseName, SQLiteDatabase.CursorFactory factory, int databaseVersion, int configFileId) {
        super(context, databaseName, factory, databaseVersion, configFileId);
        yTableUtils = new YTableUtils(connectionSource);
    }

    /**
     * 构造函数
     * @param context
     * @param databaseName
     * @param factory
     * @param databaseVersion
     * @param configFile
     */
    public YDataHelper(Context context, String databaseName, SQLiteDatabase.CursorFactory factory, int databaseVersion, File configFile) {
        super(context, databaseName, factory, databaseVersion, configFile);
        yTableUtils = new YTableUtils(connectionSource);
    }

    /**
     * 构造函数
     * @param context
     * @param databaseName
     * @param factory
     * @param databaseVersion
     * @param stream
     */
    public YDataHelper(Context context, String databaseName, SQLiteDatabase.CursorFactory factory, int databaseVersion, InputStream stream) {
        super(context, databaseName, factory, databaseVersion, stream);
        yTableUtils = new YTableUtils(connectionSource);
    }

    /**
     * 仿单例模式得到一个YTableUtils
     * @return
     */
    public YTableUtils getTableUtils(){
        if (yTableUtils == null){
            yTableUtils = new YTableUtils(connectionSource);
        } else if (yTableUtils.getConnectionSource() == null) {
            yTableUtils.setConnectionSource(getConnectionSource());
        }
        return yTableUtils;
    }

    /**
     * 数据库第一次被调用的时候会调用onCreate函数，在这里建立你的数据库
     * @param database
     * @param connectionSource
     */
    @Override
    public void onCreate(SQLiteDatabase database, ConnectionSource connectionSource) {

    }

    /**
     * 数据库升级的时候会被调用
     * @param database
     * @param connectionSource
     * @param oldVersion
     * @param newVersion
     */
    @Override
    public void onUpgrade(SQLiteDatabase database, ConnectionSource connectionSource, int oldVersion, int newVersion) {

    }

    /**
     * 调用Transaction
     * @param transaction 在Transaction中想做的操作
     * @param onFail 如果Transaction错误了做的操作
     */
    public void doInTransaction(Callable transaction,Callable onFail){
        try {
            TransactionManager.callInTransaction(getConnectionSource(), transaction);
        } catch (Exception e){
            try {
                if (onFail!=null) {
                    onFail.call();
                }
            } catch (Exception e1){
                e1.printStackTrace();
            }
            e.printStackTrace();
        }
    }

}
